From e8b11749f031428f743c1e01a6934f6ff34cec16 Mon Sep 17 00:00:00 2001
From: Linus Torvalds <torvalds@ppc970.osdl.org>
Date: Tue, 21 Jun 2005 11:03:11 -0700
Subject: Make "git checkout" know about different branches

Now "git checkout xyzzy" will check out branch "xyzzy" and
switch the HEAD to it.
---
 git-checkout-script | 39 +++++++++++++++++++++++----------------
 1 file changed, 23 insertions(+), 16 deletions(-)

(limited to 'git-checkout-script')

diff --git a/git-checkout-script b/git-checkout-script
index dc1cffde0..a3bfae79d 100755
--- a/git-checkout-script
+++ b/git-checkout-script
@@ -1,27 +1,35 @@
 #!/bin/sh
 : ${GIT_DIR=.git}
 old=$(git-rev-parse HEAD)
-new=$(git-rev-parse --revs-only "$@")
-new=${new:-$old}
-args=($(git-rev-parse --no-revs "$@"))
-
-i=0
+new=
 force=
-update=
-while [ $i -lt ${#args} ]; do
-    case "${args[$i]}" in
+branch=
+while [ "$#" != "0" ]; do
+    arg="$1"
+    shift
+    case "$arg" in
 	"-f")
-		force=1;;
-	"-u")
-		update=1;;
-	"")
+		force=1
 		;;
 	*)
-		echo "unknown flag ${args[$i]}"
-		exit 1;;
+		rev=$(git-rev-parse "$arg")
+		if [ -z "$rev" ]; then
+			echo "unknown flag $arg"
+			exit 1
+		fi
+		if [ "$new" ]; then
+			echo "Multiple revisions?"
+			exit 1
+		fi
+		new="$rev"
+		if [ -f "$GIT_DIR/revs/heads/$arg" ]; then
+			branch="$arg"
+		fi
+		;;
     esac
     i=$(($i+1))
 done
+: ${new=$old}
 
 if [ "$force" ]
 then
@@ -29,5 +37,4 @@ then
 	git-checkout-cache -q -f -u -a
 else
     git-read-tree -m -u $old $new
-fi && [ "$update" ] && echo $new > "$GIT_DIR/HEAD"
-
+fi && [ "$branch" ] && ln -sf "refs/heads/$branch" "$GIT_DIR/HEAD"
-- 
cgit v1.2.1